<template>
  <div>

    <div class="row-header">
      <h2>Что заменяем</h2>
    </div>

    <div class="main-service service-row">
      <service-selector
          :initial-active-transport="mainUuid"
          :isTransportTypeRequired="true"
          :disable-transport-type="!!mainUuid"
          :disable-transport="!!mainUuid"
          :disable-item-func="disableMainItem"
          @activeTransportTypeChanged="onMainUuidChanged"
      />
    </div>

    <div class="row-header">
      <h2>На что можно заменить</h2>
    </div>

    <div class="replacement-services-list">
      <div
          v-for="(item, i) in replacementUuidsForUi"
          :key="`replacementUuid_${item.key}`"
          class="replacement-service service-row"
      >
        <service-selector
            :is-multiselect-transport="true"
            :disable-item-func="disableReplacementItem"
            @activeTransportTypeChanged="onChangeReplacementUuid(i, $event)"
        />
        <div class="remove-service">
          <i
              class="icon close"
              title="Удалить"
              data-qa="removeReplacementUuid"
              @click="removeReplacementUuid(i)"
          />
        </div>
      </div>
    </div>

    <ObButton
        label="Добавить услуги"
        type="flat"
        icon="plus"
        data-qa="addReplacementUuid"
        @click="addReplacementUuid"
    />

    <template v-if="showError">
      <ob-alert
          hideCloseButton
          theme="danger"
          icon="alert"
      >
        Во время исполнения операции возникла ошибка. Попробуйте повторить попытку чуть позже. При повторном возникновении ошибки обратитесь в службу поддержки.
      </ob-alert>
    </template>

    <div class="actions">
      <ob-button
          type="primary"
          :disabled="disableSaveBtn"
          label="Добавить"
          @click.native="onSubmit"
      />
      <ob-button
          type="flat"
          label="Отмена"
          @click.native="$emit('close')"
      />
    </div>
  </div>
</template>

<script>
import api from "@/api"
import {uuid as vue_uuid} from 'vue-uuid';
import ObButton from "common-components/src/obComponents/obButton";
import obAlert from "common-components/src/obComponents/obAlert";
import ServiceSelector from "./ServiceSelector";

export default {

  name: "ServiceReplacementModal",

  components: {
    ObButton,
    obAlert,
    ServiceSelector,
  },

  props: {
    mainUuid: {
      type: String,
      default: ''
    },

    replacementUuids: {
      type: Array,
      default: () => [],
    },

    selectedMap: {
      type: Object,
      default: () => {},
    }
  },

  data() {
    return {
      mainUuidForUi: '',
      replacementUuidsForUi: [],
      showError: false,
    }
  },

  computed: {
    replacementUuidsValues() {
      return this.replacementUuidsForUi.flatMap(item => item.uuid).filter(uuid => uuid !== "");
    },

    disableSaveBtn() {
      return !this.mainUuidForUi || !this.replacementUuidsValues.length;
    },
  },

  watch: {
    mainUuid() {
      this.initMainUuid();
    },

    replacementUuids() {
      this.initReplacementUuids();
    }
  },

  mounted() {
    this.initMainUuid();
    this.initReplacementUuids();
  },

  methods: {

    initMainUuid() {
      this.mainUuidForUi = this.mainUuid;
    },

    initReplacementUuids() {
      if (!this.replacementUuids || !this.replacementUuids.length) {
        this.replacementUuidsForUi = [];
        this.addReplacementUuid();
      } else {
        this.replacementUuidsForUi = this.replacementUuids.map(uuid => this.getReplacementUuidForUi(uuid));
      }
    },

    addReplacementUuid(uuid) {
      this.replacementUuidsForUi.push(this.getReplacementUuidForUi(uuid));
    },
    
    getReplacementUuidForUi(uuid) {
      return {
        uuid: uuid ? [ uuid ] : [],
        key: vue_uuid.v4()
      }
    },

    removeReplacementUuid(pos) {
      if (this.replacementUuidsForUi.length > 1) {
        this.replacementUuidsForUi.splice(pos, 1);
      }
    },

    onMainUuidChanged(value) {
      this.mainUuidForUi = value;
    },

    onChangeReplacementUuid(pos, value) {
      this.replacementUuidsForUi[pos].uuid = value;
    },

    async onSubmit() {
      try {
        this.showError = false;
        await api.services.addReplaceableServices(this.mainUuidForUi, this.replacementUuidsValues);
        this.$emit("submitted");
      } catch (e) {
        this.showError = true;
        console.error(e);
        this.$notification({
          type: "system_notification_error",
          message: "Ошибка при сохранении"
        });
      }
    },

    disableMainItem(uuid) {
      return Boolean(this.selectedMap[uuid]);
    },

    disableReplacementItem(uuid) {
      return Boolean(this.selectedMap[this.mainUuidForUi]?.[uuid]);
    }
  }
}
</script>

<style lang="scss">

.row-header {
  margin: 30px 0 10px 0;
}

.main-service {
  padding-right: 30px;
}

.service-row + .service-row{
  margin-top: 10px;
}

.replacement-services-list {
  margin-bottom: 10px;
  max-height: 320px;
  overflow-y: auto;
}

.replacement-service {
  display: flex;

  .service-selector {
    flex-grow: 1;
  }
}

.remove-service {
  align-self: center;
  margin-left: 10px;

  i {
    color: #9da0ac;
    cursor: pointer;
    font-size: 20px;
  }
}

.actions {
  display: flex;
  margin-top: 40px;
}

</style>